#include "simple-common.shader"

varying vec2 v_TexCoord;
varying vec4 v_Position;

// the texture
uniform sampler2D u_Texture;
uniform float u_Factor;


void main()
{
    vec3 color = texture2D(u_Texture, v_TexCoord).rgb * u_Factor;
#ifdef ENABLE_GAMMA_CORRECTION
    color = pow(color, vec3(1.0 / 2.2));
#endif
    gl_FragColor = vec4(color, 1.0);
}