#include "simple-common.shader"

varying vec2 v_TexCoord;
varying vec4 v_Position;

uniform sampler2D u_OldAvg;
uniform sampler2D u_NewSum;

uniform float u_TotalSampleCount;
uniform float u_NewSampleCount;

void main()
{
    vec3 oldAvg = texture2D(u_OldAvg, v_TexCoord).rgb;
    vec3 newSum = texture2D(u_NewSum, v_TexCoord).rgb;

    vec3 newAvg = oldAvg + (newSum - u_NewSampleCount * oldAvg) / u_TotalSampleCount;

    gl_FragColor = vec4(newAvg, 1.0);
}