#include "simple-common.shader"

// sphere primitive only support transient mode
#define ENABLE_TRANSIENT 1

in vec3 a_Position;     // vertices of cube of [-1,1]^3
in vec3 a_Offset;
in float a_Radius;
in vec3 a_InDirection;
in vec3 a_Color;

uniform mat4 u_ModelViewProjection;
uniform mat4 u_ModelView;

out vec3 v_ViewPosition;
out vec3 v_ViewSphereCenter;
out vec3 v_Color;
out vec3 v_InDirection;
out float v_Radius;


void main()
{
    vec3 worldPos = a_Radius * a_Position + a_Offset;
    gl_Position = u_ModelViewProjection * vec4(worldPos, 1.0);
    v_ViewPosition = (u_ModelView * vec4(worldPos, 1.0)).xyz;
    v_ViewSphereCenter = (u_ModelView * vec4(a_Offset, 1.0)).xyz;
    v_Color = a_Color;
    v_InDirection = a_InDirection;
    v_Radius = a_Radius;
}